﻿using System;
using System.Linq;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace AnglersFishingRaft {
    public class AnglersFishingRaftPlugin : HBPlugin {
	
        public static LocalPlayer Me = StyxWoW.Me;

        public static WoWItem AnglersFishingRaftItem;
		
        public override string Name {
            get { return "Anglers Fishing Raft"; }
        }

        public override string Author {
            get { return "Proto"; }
        }

        public override Version Version {
            get { return new Version(1, 3); }
        }

        public override void OnEnable() {
            Logging.Write(Colors.Orange, "Anglers Fishing Raft - Enabled");
            
            base.OnEnable();
        }

        public override void OnDisable() {
            Logging.Write(Colors.OrangeRed, "Anglers Fishing Raft - Disabled");

            base.OnDisable();
        }

        public override void Pulse() {
            if(!HasAnglersFishingRaftItem()) {
                return;
            }

            if(!CanUseAnglersFishingRaft()) {
                return;
            }

            if(HasAnglersFishingRaftBuff()) {
                return;
            }

            if(IsAnglersFishingRaftOnCooldown()) {
                return;
            }

            UseAnglersFishingRaft();
			WoWMovement.Move(WoWMovement.MovementDirection.JumpAscend, TimeSpan.FromMilliseconds(200));
        }

        public static bool IsViable(WoWObject pWoWObject) {
            return (pWoWObject != null) && pWoWObject.IsValid;
        }

        public static bool HasAnglersFishingRaftItem() {
            AnglersFishingRaftItem = Me.BagItems.FirstOrDefault(item => item.Entry == 85500);

            return AnglersFishingRaftItem != null;
        }

        public static bool CanUseAnglersFishingRaft() {
            return IsViable(Me) && Me.IsSwimming && !Me.Combat && !Me.Mounted && !Me.IsDead && !Me.InVehicle && !Me.IsChanneling && !Me.IsFlying && !Me.IsCasting && !Me.OnTaxi;
        }

        public static bool HasAnglersFishingRaftBuff() {
            return Me.HasAura(124036);
        }

        public static void UseAnglersFishingRaft() {
            AnglersFishingRaftItem.Use();
        }

        public static bool IsAnglersFishingRaftOnCooldown() {
            return AnglersFishingRaftItem.Cooldown > 0;
        }
    }
}